package betterwithmods.common.blocks;

import betterwithmods.api.block.IMultiVariants;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMRecipes;
import betterwithmods.module.hardcore.HCBonemeal;
import betterwithmods.util.InvUtils;
import net.minecraft.block.Block;
import net.minecraft.block.BlockSand;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.init.SoundEvents;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemHoe;
import net.minecraft.item.ItemStack;
import net.minecraft.util.*;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.ColorizerGrass;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraft.world.biome.BiomeColorHelper;
import net.minecraftforge.common.EnumPlantType;
import net.minecraftforge.common.IPlantable;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.Arrays;
import java.util.Random;

public class BlockPlanter extends BWMBlock implements IMultiVariants {
    public static final PropertyEnum<EnumType> TYPE = PropertyEnum.func_177709_a("plantertype", EnumType.class);

    public BlockPlanter() {
        super(Material.field_151576_e);
        this.func_149675_a(true);
        this.func_149711_c(1.0F);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(TYPE, EnumType.EMPTY));
        this.setHarvestLevel("pickaxe", 0);
    }

    public static ItemStack getStack(EnumType type) {
        return new ItemStack(BWMBlocks.PLANTER, 1, type.getMeta());
    }

    @Override
    public String[] getVariants() {
        return new String[]{"plantertype=empty", "plantertype=dirt", "plantertype=grass", "plantertype=soul_sand", "plantertype=fertile", "plantertype=sand", "plantertype=water_still", "plantertype=gravel", "plantertype=red_sand"};
    }

    public int colorMultiplier(IBlockState state, IBlockAccess world, BlockPos pos, int tintIndex) {
        return (state.func_177229_b(TYPE) == EnumType.GRASS && tintIndex > -1) ? world != null && pos != null ? BiomeColorHelper.func_180286_a(world, pos) : ColorizerGrass.func_77480_a(0.5D, 1.0D) : -1;
    }

    @Override
    public int func_180651_a(IBlockState state) {
        return state.func_177229_b(TYPE).getMeta();
    }

    private boolean isValidBlockStack(ItemStack stack) {
        if (stack.func_77973_b() instanceof ItemBlock) {
            Block block = ((ItemBlock) stack.func_77973_b()).func_179223_d();
            return block == Blocks.field_150346_d || block == Blocks.field_150349_c || block == Blocks.field_150354_m || block == Blocks.field_150351_n || block == Blocks.field_150425_aM;
        }
        return false;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        IBlockState planter = world.func_180495_p(pos);
        ItemStack heldItem = player.func_184586_b(hand);
        int meta = world.func_180495_p(pos).func_177229_b(TYPE).getMeta();
        if (world.field_72995_K) {
            ItemStack item = hand == EnumHand.MAIN_HAND ? player.func_184614_ca() : player.func_184592_cb();
            if (!item.func_190926_b()) {
                if (meta == 0 && (isValidBlockStack(item) || item.func_77973_b() == Items.field_151131_as))
                    return true;
                else if (meta == 1 && (HCBonemeal.FERTILIZERS.stream().anyMatch(item::func_77969_a)))
                    return true;
                else if (meta == 2 && item.func_77973_b() instanceof ItemHoe)
                    return true;
                else if (meta != 0 && meta != 6 && item.func_77973_b().getHarvestLevel(player.func_184586_b(hand), "shovel", player, planter) > -1)
                    return true;
                else if (meta == 6 && item.func_77973_b() == Items.field_151133_ar)
                    return true;
            }
            return false;
        }

        if (meta == 0) {
            ItemStack stack = hand == EnumHand.MAIN_HAND ? player.func_184614_ca() : player.func_184592_cb();
            if (!stack.func_190926_b()) {
                boolean valid = false;

                if (stack.func_77973_b() == Items.field_151131_as) {
                    world.func_175656_a(pos, planter.func_177226_a(TYPE, EnumType.WATER));
                    world.func_184133_a(null, pos, SoundEvents.field_187624_K, SoundCategory.BLOCKS, 1.0F, world.field_73012_v.nextFloat() * 0.1F + 0.9F);
                    ItemStack replacement = stack.func_77973_b().getContainerItem(stack);
                    if (stack.func_190916_E() == 1 && !player.field_71075_bZ.field_75098_d) {
                        EntityEquipmentSlot slot = EntityEquipmentSlot.MAINHAND;
                        if (hand == EnumHand.OFF_HAND)
                            slot = EntityEquipmentSlot.OFFHAND;
                        player.func_184201_a(slot, replacement);
                    } else {
                        if (!player.field_71075_bZ.field_75098_d) {
                            if (!player.field_71071_by.func_70441_a(replacement)) {
                                InvUtils.ejectStackWithOffset(world, new BlockPos(player.field_70118_ct, player.field_70117_cu, player.field_70116_cv), replacement);
                            }
                        }
                    }
                    valid = true;
                } else if (stack.func_77973_b() instanceof ItemBlock) {
                    Block block = ((ItemBlock) stack.func_77973_b()).func_179223_d();
                    if (this.isValidBlockStack(stack)) {
                        if (!player.field_71075_bZ.field_75098_d)
                            stack.func_190918_g(1);
                        for (EnumType type : EnumType.values()) {
                            if (valid)
                                break;
                            if (BWMRecipes.getStackFromState(type.getState()).func_77969_a(stack)) {
                                world.func_175656_a(pos, state.func_177226_a(TYPE, type));
                                valid = true;
                            }
                        }
                    }
                    if (valid)
                        world.func_184133_a(null, pos, block.getSoundType(state, world, pos, player).func_185841_e(), SoundCategory.BLOCKS, 1.0F, world.field_73012_v.nextFloat() * 0.1F + 0.9F);
                }
                return valid;
            }
        } else if (meta == 1) {
            if (!heldItem.func_190926_b()) {
                if (heldItem.func_77973_b() == Items.field_151100_aR && heldItem.func_77952_i() == 15) {
                    world.func_175656_a(pos, planter.func_177226_a(TYPE, EnumType.FERTILE));
                    if (!player.field_71075_bZ.field_75098_d)
                        heldItem.func_190918_g(1);
                    world.func_184133_a(null, pos, SoundEvents.field_187638_cR, SoundCategory.BLOCKS, 0.25F, ((world.field_73012_v.nextFloat() - world.field_73012_v.nextFloat()) * 0.7F + 1.0F) * 2.0F);
                    return true;
                }
            }
        }
        if (meta != 6 && !heldItem.func_190926_b() && heldItem.func_77973_b().getHarvestLevel(heldItem, "shovel", player, planter) > -1) {
            EnumType type = state.func_177229_b(TYPE);
            if (!player.field_71075_bZ.field_75098_d) {
                if (!player.field_71071_by.func_70441_a(BWMRecipes.getStackFromState(type.getState())))
                    player.func_71019_a(BWMRecipes.getStackFromState(type.getState()), false);
            }
            world.func_184133_a(null, pos, type.getState().func_177230_c().getSoundType(state, world, pos, player).func_185841_e(), SoundCategory.BLOCKS, 1.0F, world.field_73012_v.nextFloat() * 0.1F + 0.9F);
            world.func_175656_a(pos, state.func_177226_a(TYPE, EnumType.EMPTY));
            return true;
        } else if (meta == 2 && heldItem.func_77973_b() instanceof ItemHoe) {
            world.func_184133_a(null, pos, SoundEvents.field_187693_cj, SoundCategory.BLOCKS, 1.0F, world.field_73012_v.nextFloat() * 0.1F + 0.9F);
            world.func_175656_a(pos, state.func_177226_a(TYPE, EnumType.DIRT));
            return true;
        } else if (meta == 6 && heldItem.func_77973_b() == Items.field_151133_ar) {
            if (!player.field_71075_bZ.field_75098_d) {
                if (heldItem.func_190916_E() == 1) {
                    EntityEquipmentSlot slot = EntityEquipmentSlot.MAINHAND;
                    if (hand == EnumHand.OFF_HAND)
                        slot = EntityEquipmentSlot.OFFHAND;
                    player.func_184201_a(slot, new ItemStack(Items.field_151131_as));
                } else {
                    heldItem.func_190918_g(1);
                    if (!player.field_71071_by.func_70441_a(new ItemStack(Items.field_151131_as)))
                        player.func_71019_a(new ItemStack(Items.field_151131_as), false);
                }
            }
            world.func_184133_a(null, pos, SoundEvents.field_187630_M, SoundCategory.BLOCKS, 1.0F, world.field_73012_v.nextFloat() * 0.1F + 0.9F);
            world.func_175656_a(pos, state.func_177226_a(TYPE, EnumType.EMPTY));
            return true;
        }
        return false;
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        if (!world.field_72995_K) {
            int meta = world.func_180495_p(pos).func_177229_b(TYPE).getMeta();
            BlockPos up = pos.func_177984_a();
            if (world.func_175623_d(up)) {
                if (meta == 1) {
                    if (world.func_175699_k(up) > 8) {
                        int xP = rand.nextInt(3) - 1;
                        int yP = rand.nextInt(3) - 1;
                        int zP = rand.nextInt(3) - 1;
                        BlockPos checkPos = pos.func_177982_a(xP, yP, zP);
                        if (world.func_180495_p(checkPos).func_177230_c() == Blocks.field_150349_c)
                            world.func_175656_a(pos, this.func_176223_P().func_177226_a(TYPE, EnumType.GRASS));
                    }
                } else if (meta == 2 && rand.nextInt(30) == 0) {
                    world.func_180494_b(pos).plantFlower(world, rand, up);
                    if (world.func_175699_k(up) > 8) {
                        for (int i = 0; i < 4; i++) {
                            int xP = rand.nextInt(3) - 1;
                            int yP = rand.nextInt(3) - 1;
                            int zP = rand.nextInt(3) - 1;
                            BlockPos checkPos = pos.func_177982_a(xP, yP, zP);
                            if (world.func_180495_p(checkPos) == Blocks.field_150346_d && world.func_180495_p(checkPos) == Blocks.field_150346_d.func_176223_P())
                                world.func_175656_a(checkPos, Blocks.field_150349_c.func_176223_P());
                        }
                    }
                }
            } else if (world.func_180495_p(up).func_177230_c() instanceof IPlantable) {
                IPlantable plant = (IPlantable) world.func_180495_p(up).func_177230_c();
                if (this.canSustainPlant(world.func_180495_p(pos), world, pos, EnumFacing.UP, plant) && world.func_180495_p(up).func_177230_c().func_149653_t()) {
                    IBlockState cropState = world.func_180495_p(up);
                    world.func_180495_p(up).func_177230_c().func_180650_b(world, up, cropState, rand);
                    if (meta == 4) {
                        world.func_180495_p(up).func_177230_c().func_180650_b(world, up, cropState, rand);
                        if (rand.nextInt(100) == 0)
                            world.func_175656_a(pos, this.func_176223_P().func_177226_a(TYPE, EnumType.DIRT));
                    }
                }
            }
        }
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public boolean func_176225_a(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing side) {
        return true;
    }

    @Override
    public boolean isFertile(World world, BlockPos pos) {
        return world.func_180495_p(pos).func_177229_b(TYPE) == EnumType.FERTILE;
    }

    @Override
    public boolean canSustainPlant(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing dir, IPlantable plant) {
        BlockPos up = pos.func_177984_a();
        EnumPlantType plantType = plant.getPlantType(world, up);
        return dir == EnumFacing.UP && world.func_180495_p(pos).func_177229_b(TYPE).isType(plantType);
    }

    @Override
    public void func_149666_a(CreativeTabs itemIn, NonNullList<ItemStack> items) {
        for (EnumType type : EnumType.VALUES)
            items.add(getStack(type));
    }

    @Override
    public void onPlantGrow(IBlockState state, World world, BlockPos pos, BlockPos source) {
        if (state.func_177229_b(TYPE) == EnumType.GRASS && source.func_177956_o() == pos.func_177956_o() + 1)
            world.func_175656_a(pos, state.func_177226_a(TYPE, EnumType.DIRT));
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, TYPE);
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(TYPE, EnumType.byMeta(meta));
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(TYPE).getMeta();
    }

    public enum EnumType implements IStringSerializable {
        EMPTY("empty", Blocks.field_150350_a.func_176223_P(), 0, new EnumPlantType[0]),
        DIRT("dirt", Blocks.field_150346_d.func_176223_P(), 1, new EnumPlantType[]{EnumPlantType.Crop, EnumPlantType.Plains}),
        GRASS("grass", Blocks.field_150349_c.func_176223_P(), 2, new EnumPlantType[]{EnumPlantType.Plains}),
        SOULSAND("soul_sand", Blocks.field_150425_aM.func_176223_P(), 3, new EnumPlantType[]{EnumPlantType.Nether}),
        FERTILE("fertile", Blocks.field_150346_d.func_176223_P(), 4, new EnumPlantType[]{EnumPlantType.Crop, EnumPlantType.Plains}),
        SAND("sand", Blocks.field_150354_m.func_176223_P(), 5, new EnumPlantType[]{EnumPlantType.Desert, EnumPlantType.Beach}),
        WATER("water_still", Blocks.field_150355_j.func_176223_P(), 6, new EnumPlantType[]{EnumPlantType.Water}),
        GRAVEL("gravel", Blocks.field_150351_n.func_176223_P(), 7, new EnumPlantType[]{EnumPlantType.Cave}),
        REDSAND("red_sand", Blocks.field_150354_m.func_176223_P().func_177226_a(BlockSand.field_176504_a, BlockSand.EnumType.RED_SAND), 8, new EnumPlantType[]{EnumPlantType.Desert, EnumPlantType.Beach});
        private static final EnumType[] VALUES = values();

        private String name;
        private IBlockState state;
        private int meta;
        private EnumPlantType[] type;

        EnumType(String name, IBlockState state, int meta, EnumPlantType[] type) {
            this.name = name;
            this.state = state;
            this.meta = meta;
            this.type = type;
        }

        public static EnumType byMeta(int meta) {
            if (meta > 8)
                return EMPTY;
            return VALUES[meta];
        }

        @Override
        public String func_176610_l() {
            return name;
        }

        public int getMeta() {
            return meta;
        }

        public boolean isType(EnumPlantType type) {
            return this.type.length != 0 && Arrays.asList(this.type).contains(type);
        }

        public IBlockState getState() {
            return state;
        }
    }
}
